﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class GameController : MonoBehaviour {
	public GameObject Box;
	public GameObject Pigeon;
    public GameObject buildingThing;
    public Transform targetBuilding;
    public GameObject partySound;
	public Camera MainCamera;

	public Camera DropCamera;
	bool dropping = false;
	PigeonControlScript PCS;

    public Text pointsText;
    public Text deliveredText;
    public Text timeText;

    public float points = 0;
    public int delivered = 0;

    public float timerSeconds = 120f;

    public bool growingBuilding = true;

    public List<Transform> buildings;

    public string loadToLevel = "Gameover";

    // Use this for initialization
    void Start () {
		MainCamera = GameObject.Find ("Main Camera").GetComponent<Camera> ();
		DropCamera = GameObject.Find ("DropCamera").GetComponent<Camera> ();
		DropCamera.gameObject.SetActive (false);
		PCS = GameObject.Find ("Pizzeon").GetComponent<PigeonControlScript> ();
        //buildings = buildingThing.gameObject.GetComponentsInChildren<Transform>();
        foreach (var traa in buildingThing.transform)
        {
            Transform t = (Transform)traa;
            buildings.Add(t);
        }
        NewTarget();
        StartCoroutine(timerCountDown());
        StartCoroutine(throbbingBuilding());
    }
	
	// Update is called once per frame
	void Update () {
        pointsText.text = "Points: " + Mathf.Floor(points);
        deliveredText.text = "Delivered: " + delivered;
        if(timerSeconds <= 0)
        {
            FindObjectOfType<ScreenFader>().FadeTo(loadToLevel);
        }
    }

	public void dropBox () {
		if (!dropping) {
			MainCamera.gameObject.SetActive (false);
			Instantiate (Box, transform.position + transform.up, transform.rotation);
			DropCamera.gameObject.SetActive (false);
			dropping = true;
		}	
	}

	public void wakePigeon () {
		if (dropping)
		PCS.Dropping = false;
		Pigeon.GetComponent<Rigidbody> ().isKinematic = false;
		MainCamera.gameObject.SetActive (true);
		DropCamera.gameObject.SetActive (false);
		dropping = false;
	}

	public void DropMode() {
		MainCamera.gameObject.SetActive (false);
		DropCamera.gameObject.SetActive (true);
	}

    public void NewTarget()
    {
        targetBuilding = buildings[Random.Range(0, buildings.Count - 1)];
        partySound.transform.position = targetBuilding.position;
		StartCoroutine (throbbingBuilding ());
    }

    IEnumerator timerCountDown()
    {
        while(timerSeconds > 0)
        {
            timerSeconds -= Time.deltaTime;
            timeText.text = "Time left: " + Mathf.Floor(timerSeconds);
            yield return null;
        }
    }
    IEnumerator throbbingBuilding()
    {
        Vector3 originalScale = targetBuilding.localScale;
        Vector3 minScale = originalScale * 0.5f;
        Vector3 maxScale = originalScale * 1.5f;

        float timer = 0;
        float growTime = 1f;
		var originalT = targetBuilding;
        while (true) {
            float growDelta = maxScale.x - minScale.x;

            while (timer < growTime) {
				
				if (targetBuilding != originalT) {
					originalT.transform.localScale = originalScale;
					yield break;
				}

                timer += Time.deltaTime;

                float i = timer / growTime;
                
                float scale = minScale.x + growDelta * i;
                targetBuilding.localScale = new Vector3(scale, scale, scale);

                yield return null;

            }

            while (timer > 0)
            {
				if (targetBuilding != originalT) {
					originalT.transform.localScale = originalScale;
					yield break;
				}

                timer -= Time.deltaTime;

                float i = timer / growTime;

                float scale = minScale.x + growDelta * i;
                targetBuilding.localScale = new Vector3(scale, scale, scale);

                yield return null;

            }
        }
        
    }
}
