﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PigeonControlScript : MonoBehaviour
{
    public Rigidbody rb;

    public float speed = 20f;

    public GameObject flightdir;
    public GameObject cameraRail;
    public GameObject planet;

    public float radius = 120f;
	bool DropMode = false;
	bool DroppiMode = false;
	public bool Dropping = false;

    public Animator anim;

    float xRot = 0;
    float yRot = 0;

	GameController GC;

    // Use this for initialization
    void Start () {
        //rb = GetComponent<Rigidbody>();
		GC = GameObject.Find ("GameController").GetComponent<GameController> ();
    }
	
	// Update is called once per frame
	void Update () {

        cameraRail.transform.localPosition = Vector3.MoveTowards(cameraRail.transform.localPosition, new Vector3(0, 0, -speed / 10), Time.deltaTime);

        if (speed > 5f)
        {
            speed -= Time.deltaTime * 8;
        }
        //Debug.Log(Vector3.Distance(transform.position, planet.transform.position));

        float distance = Vector3.Distance(transform.position, planet.transform.position);

        if (distance > radius)
        {
            Vector3 fromOriginToObject = transform.position - planet.transform.position; 
            fromOriginToObject *= radius / distance; 
            rb.transform.position = planet.transform.position + fromOriginToObject; 
        }
        
        rb.AddForce(flightdir.transform.forward * speed, ForceMode.Force);
        xRot += -Input.GetAxis("Mouse Y");
        yRot += Input.GetAxis("Mouse X");
        transform.localRotation = Quaternion.Euler(new Vector3(xRot, yRot, 0));

        if (Input.GetKeyDown("space") && speed < 40f)
        {
            StartCoroutine(SpeedUp());
            anim.SetTrigger("Fly");
        }

		if (Input.GetMouseButtonDown(1) && !Dropping) {
			GC.DropMode ();
			DroppiMode = true;
		}
		if (Input.GetMouseButtonUp(1) && DroppiMode) {
			DropMode = true;
			DroppiMode = false;
			Dropping = true;
		}

		if (Input.GetMouseButtonDown(1) && DropMode) {
			GC.dropBox ();
			rb.isKinematic = true;
			DropMode = false;
		}

		if (Input.GetMouseButtonDown(0) && DropMode) {
			GC.wakePigeon();
			DropMode = false;
			Dropping = false;
		}
    }

    IEnumerator SpeedUp()
    {
        float count = 0f;

        while(count < 0.5f)
        {
            count += Time.deltaTime;
            speed += Time.deltaTime * 6;
            yield return null;
        }
    }   
}
