﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ScoreKeeper : MonoBehaviour {

	static bool spawnedAlready = false;

    public GameController gc;
    public int points;
    public int delivered;

    Text scoreText;
    Text deliveredText;

    // Use this for initialization

	void Awake(){
		if(spawnedAlready){
			DestroyImmediate (this.gameObject);
			return;
		}
	}
    void Start () {
		if(spawnedAlready){
			return;
		}
        DontDestroyOnLoad(this);
		spawnedAlready = true;
    }
    void OnLevelWasLoaded(int level)
    {
		gc = FindObjectOfType<GameController> ();
		if (level == 4) {
			scoreText = GameObject.Find ("ScoreText").GetComponent<Text> ();
			deliveredText = GameObject.Find ("DeliveredText").GetComponent<Text> ();

			scoreText.text = "" + points;
			deliveredText.text = "" + delivered;
		} else if(level == 0){
			points = 0;
			delivered = 0;
		}
    }

    // Update is called once per frame
    void Update () {
        if (gc != null)
        {
            points = (int)gc.points;
            delivered = (int)gc.delivered;
        }
    }
}
